// flac2mp3.js  -  JScript script, tested under WSH 5.6 in WinXP Pro
//
// This script converts all flac files found in the same folder
// as the script, to mp3 files, attempting to preserve metadata.
//
// It also requires metaflac, flac, lame in the same folder.
//
// The script decodes, encodes and tags one file at a time, so there
// should be a maximum of one temporary wav file at any given time.
//
// -tnl  (tnl ta asia tod com)
//
//
// Notes:
//
// If the script doesn't appear to finish, run wscript.exe
// (Start -> Run -> wscript).
//
// Make sure that the option to stop the script after some time, is disabled.
//
// Given my assumption that WSH is notorious for introducing malware, you may
// want to reenable this timeout, although I'm not sure how much it helps.

// Edit this script as necessary


function dquote(path) { return '"'+ path +'"'; }

function main() {
  //options
  var extra_lame_flags = "-V 1 --vbr-new --ignore-tag-errors --add-id3v2";
  var do_open_folder_when_done = true;

  var dir = WScript.ScriptFullName.substr(
    0, WScript.ScriptFullName.length - WScript.ScriptName.length);

  var out_dir = dir +"mp3s\\"; //include trailing slash

  var sh = new ActiveXObject('Wscript.Shell');
  if (sh.Popup('Convert FLACs in\n'+ dir
    +'\n\nto MP3s in\n'+ out_dir +'\n ', 0, 'flac2mp3', 4+32) == 7
  ) {
    sh.Popup('Operation aborted!', 1, 'flac2mp3', 0+64);
    return;
  }
  if (do_open_folder_when_done) {
    sh.Popup(
      'When this script finishes, '
      +'it will open the folder containing the MP3s.',
      4, 'flac2mp3', 0+64);
  }

  sh.Run('"%comspec%" /c mkdir '+ dquote(out_dir), 0, true);
  var fs = new ActiveXObject('Scripting.FileSystemObject');
  var e = new Enumerator(fs.GetFolder(dir).files);
  var file, base;
  for (e.moveFirst(); !e.atEnd(); e.moveNext()) {
    file = e.item();
    if (base = file.name.match(/(.+)\.flac$/i)) {
      base = base[1];
      sh.Run(
        dquote(dir +'metaflac.exe')
        +' --export-tags-to='+ dquote(dir + base +'.tags')+' '+ dquote(file)
        , 0, true);
      sh.Run(
        dquote(dir +'flac.exe') +' -d '+ dquote(file), 7, true);
      sh.Run(
        dquote(dir +'lame.exe') +' '+ tag_opts(dir + base +'.tags')
        +' '+extra_lame_flags+' '
        + dquote(dir + base +'.wav') +' '+ dquote(out_dir + base +'.mp3')
        , 7, true);
      sh.Run('"%comspec%" /c del '+ dquote(dir + base +'.tags'), 0);
      sh.Run('"%comspec%" /c del '+ dquote(dir + base +'.wav'), 0);
    }
  }
  if (do_open_folder_when_done) {
    sh.Run('explorer.exe '+ dquote(out_dir));
  }
}

// Attempt to return command line options for lame tagging based on metaflac's
// exported tags file format.  No support for arbitrary tag names at this time.
function tag_opts(tag_file) {
  var fs = new ActiveXObject('Scripting.FileSystemObject');
  var ts = fs.OpenTextFile(tag_file);
  var opts = {
    title:'tt', artist:'ta', album:'tl', date:'ty',
    comment:'tc', tracknumber:'tn',
    year:'ty', track:'tn'
    };
  var tags = '', line, m, opt;
  while (!ts.AtEndOfStream) {
    line = ts.ReadLine();
    m = line.match(/^([a-zA-Z]+)=(.+)$/);
    if (m && m[1] && m[2]) {
      opt = opts[ (''+ m[1]).toLowerCase() ];
      if (opt) {
        tags += ' --'+ opt +' '+ dquote( (''+ m[2]).replace(/"/g, '\\"') );
      }
    }
  }
  ts.Close();
  return tags;
}

main();
